% Article proposed to mdpi-INVENTIONS
%The evolutionary algorithm EAv0 for Ethanol production.
% For solving optimal control problems
%The population of each generation has ? =N individuals;
% The offspring population has ? =20 individuals;

%The selection strategy is based on Stochastic Universal Sampling
% using the rank of individuals, which is scaled linearly
% using selection pressure (s)
% The replacement strategy: the offspring replace the ? worst parents of the generation
% A BLX-? crossover operator
%The mutation operator uses global variance adaptation of the mutation step.
% The adaptation is made according to the "1/5 success rule"
% NGen is the number of generations in which the population is evolving;

global t_vector horiz;
global Nt N s;
global pop;
global CHILD;
global ngene NGen;
global xmin xmax;
global dTdtmax;
global fc fcCHILD;
global amic;

global nr_fii;
global sigma msc mc;
global X00;
N=30;              % N=nr de cromozomi din populatie
nr_fii=20;
NGen=70;     % NGen=nr de generatii
fc=zeros(N,1);
fcCHILD=zeros(nr_fii,1);
dTdtmax=4.;
xmin=0.;
xmax=12.;
Nt=20;
ngene=Nt;
parinti=zeros(nr_fii,1);
s=1.8; %presiune de selectie
str=sprintf('#####  N=%d nr_fii=%d NGen=%d s=%g  dTdtmax=%g',...
    N, nr_fii,NGen,s,dTdtmax);
disp(str);
amic=0.7;
X00=[1. 150. 0. 10.];
horiz=54.;
delt=horiz/Nt;
t_vector=0:delt:horiz; % are Nt+1 elemente
R=N:-1:1; % Rangurile populatiei. Solutiile sunt ordonate;
          % miu=N
P=ScaleRank(R,N,s);%P contine rangurile scalate
lambda=nr_fii;
pop=zeros(N,ngene);
CHILD=zeros(nr_fii,ngene);

%Generare populatie initiala
 for i=1:N
    for j=1:ngene     
          pop(i,j)=3.0+random('unif',-j/10, j/10);
    end
 end
 
%Evaluare initiala
for i=1:N
	fc(i)=eval_EP_single(pop(i,:));
end
[fc,IX]=sort(fc,1,'descend');
 pop=pop(IX,:);
sigma=0.2;
mc=0;
msc=0;

tic
 g=1;
%CICLU MARE de T ITERAII
%tttttttttttttttttttttttttttttttttttttttttttttttttttttt BEGIN
while(g<=NGen)         %&&(gasit==0)

% SELECTIE PARINTI
parinti=StUnSamp(P,N,lambda);%indicii parintilor
per=randperm(lambda);
parinti=parinti(per);%permutare aleatorie a indicilor

%INCRUCISARE - atentie aici se construiesc (aparglobal amic;) fii
for ii=1:lambda
      jj=randi(lambda);
      icucine=parinti(jj);
      %icucine=1;
      incrucisare_BLX(parinti(ii),icucine,ii); %un singur copil
      % se creaza CHILD(ii,:)        
end
%-----------------------------
 %MUTATIE (mutatieGaussRH contine si evaluarea)
 for i7=1:lambda
      fcCHILD(i7)=eval_EP_single(CHILD(i7,:));
      %Evalure inainte de mutatie pt toti fii (valabila si daca nu voi face mutatie)
      
      daca_mut=randi(100);
      if(daca_mut<=90)      
        mutatieGaussRH_g(i7); %Fac mutatie pe CHILD(i7)
        %In interior se face si StepCtrl si actualizare fcCHILD(i7)
        %mutSimp(i7,g);
      end
      %fcCHILD(i7)=eval_EP_single(CHILD(i7,:));
 end

 % Copiere fi pe ultimele lambda POZITII din cele N
 pop((N-lambda+1):N,:)=CHILD;
 fc((N-lambda+1):N)=fcCHILD;
 %------------------------------------
 % Reordonare pop dupa fc
 [fc,IX]=sort(fc,1,'descend');
 pop=pop(IX,:);   %reordoneaza
if (mod(g,10)==0)
    str=sprintf('#####   nr. gen=%g Jmax=%g sigma=%g',g, fc(1),sigma);
    disp(str);
 end
 %------------------------------------
 
 g=g+1;
% if(g==NGen)
%      c=input('Continuam ? n/d=','s');
%       if c=='d'
%         NGen=NGen+20;
%       end
% end
end     %while
toc
save('WspEA_EP_single');
% figure (2)
% stairs(t_vector,[pop(1,:),pop(1,Nt)],'-.ro');
% axis([0 54 0 12]);
% Jmax=fc(1);
% str=sprintf('******   Jmax=%8.1f ', Jmax);
% disp(str);



