% Article proposed to mdpi-INVENTIONS
% This program executes 30 times "EA_EtanolP_single.m"
% in order to calculate some statistical parameters presented in Table 4.
%The results are saved in 'WSP30single20.mat'
global X00;
global u_vector; 
global command_index;
global horiz;
global Nt;
Ustar=zeros(30,20);
JMAT=zeros(30,1);

Nt=77;
% delt=horiz/Nt;
% t_vector=0:delt:horiz;
%X00=[1. 150. 0. 10.];
ijk=1;
while (ijk<=30)    
    disp('ijk=');disp(ijk);
    EA_EtanolP_single;
    u_vector=pop(1,:);
    Ustar(ijk,:)=pop(1,:);
    command_index=1;
    tf=horiz;
     options = odeset('RelTol',0.01,'MaxStep',1., 'NonNegative',[1,2,3,4]);
     [T,Y] = ode23('EtanolProd',[0 tf],X00,options);
     IF=length(T); 
     J=Y(IF,3)*Y(IF,4);
     JMAT(ijk,1)=J;
     
     str=sprintf('Jmax=%g',J);
     disp(str); 
     disp('************************');
  ijk=ijk+1;
end 
save('WSP30single20','Ustar','JMAT');
disp(Nt);
