function [C] = StUnSamp( Fit,miu,lambda )
%Intoarce vectorul C de dimesiune lambda cu indicii  
% pentru cromozomii selectati conform Stochastic Universal Sampling
% miu: nr de cromozomi
% lambda: dimensiunea selectiei
% Fit: vector de dimensiune miu cu vaolrile fitness (sau
% echivalente) ale cromozomilor
%Generez A cu sumele partiale din Fit
A=zeros(miu,1);
B=zeros(lambda,1);
C=zeros(lambda,1);

Aim1=0; %Aim1 = A(i-1)
for i=1:miu
    A(i)=Aim1+Fit(i);
    Aim1=A(i);
end
a=360/A(miu);
A=a*A;

b=360/lambda;
b0=random('unif',0,b);

%Generare vector B[lambda]
for j=1:lambda
   B(j)=b0+(j-1)*b;
end
%disp('B=');disp(B);
for j=1:lambda   
   C(j)=Sector(B(j),A,miu);
end
end
