% Article proposed to mdpi-INVENTIONS
% This program executes 30 times "Closed_loop.m"
% in order to calculate some statistical parameters.
% The results are saved in 'WSP30loop2.mat'
global X00;
global u_vector; 
global command_index;
global horiz;

Ustar=zeros(30,20);
JMAT=zeros(30,1);

ijk=1;
while (ijk<=30)    
    disp('ijk=');disp(ijk);
    Closed_loop2;
    u_vector=ustar;
    Ustar(ijk,:)=ustar;
    command_index=1;
    tf=horiz;
     options = odeset('RelTol',0.01,'MaxStep',1., 'NonNegative',[1,2,3,4]);
     [T,Y] = ode23('EtanolProd',[0 tf],X00,options);
     IF=length(T); 
     J=Y(IF,3)*Y(IF,4);
     JMAT(ijk,1)=J;  
     str=sprintf('Jmax=%8.1f',J);%\\\\\\\\\\\\\\\\\\\\
     disp(str); 
     disp('************************');
  ijk=ijk+1;
end 
save('WSP30loop2','Ustar','JMAT'); 
