function mutatieGaussRH_g(i)
%The mutation operator uses global variance adaptation of the mutation step.
%The adaptation is made according to the "1/5 success rule"; 
% Mutation of chromozome CHILD(i,:)

global ngene xmax xmin;
global amic;
global sigma msc mc;
global dTdtmax;
global CHILD fcCHILD;

% Actualizare sigma, daca e cazul
if mc==ngene;
    sr=msc/mc; %success rate
    if sr < 0.2
        sigma=sigma*amic;
    elseif sr>0.2
           sigma=sigma/amic;
    end
    mc=0;
    msc=0;
end

fcfm=fcCHILD(i); % fc fara mutatie
%U=zeros(1,ngene);
U=random('Normal',0,sigma,1,ngene);
CHILD(i,:)=CHILD(i,:)+U;

% StepCtrl
for j=1:(ngene-1)
      if CHILD(i,j+1)-CHILD(i,j)>dTdtmax
        CHILD(i,j+1)=CHILD(i,j)+dTdtmax;
      elseif CHILD(i,j+1)-CHILD(i,j)<-dTdtmax
        CHILD(i,j+1)=CHILD(i,j)-dTdtmax;
      end
end
% Limitare
for j=1:ngene
    if CHILD(i,j)<xmin
        CHILD(i,j)=xmin;
    elseif CHILD(i,j)>xmax
        CHILD(i,j)=xmax;
    end
end

mc=mc+1;  %Contorizare mutatie

fcCHILD(i)=eval_EP_single(CHILD(i,:)); %Evalure dupa mutatie
if fcCHILD(i)>fcfm
    msc=msc+1; %Contorizare mutatii de succes
end

end

