% Article proposed to mdpi-INVENTIONS
 % Simulation of the Control loop for the Ethanol production
 % It calls repeatedly the function "Controller_EA.m" that includes EAv1 
global  horiz;
global Nt N s;
global Ncalls; %XXXXXXXXXXXXXX
global NGen;
global xmin xmax;
global dTdtmax;

global nr_fii;
%\\\\\\\\\\\\\\\\\\\\
global X0 X00;
global delt;
%/////////////
global ti;
global t_vector;
global u_vector; 
global command_index;
%\\\\\\\\\\\\\\\\\\\\

N=30;              % N=nr de cromozomi din populatie
nr_fii=20;
NGen=70;     % NGen=nr de generatii
dTdtmax=4.;
xmin=0.;
xmax=12.;
Nt=20;
ustar=zeros(1,Nt);
Ncalls=zeros(1,Nt); %XXXXXXXXXXXXXX
s=1.8; %presiune de selectie
horiz=54.;

X00=[1. 150. 0. 10.];
str=sprintf('#####  N=%d nr_fii=%d NGen=%d s=%g  dTdtmax=%g',...
    N, nr_fii,NGen,s,dTdtmax);
disp(str);
delt=horiz/Nt;
X0=X00;

for k=1:Nt
tic;  %XXXXXXXXXXXXXX
uk=Controller_EA(k);
toc;     %XXXXXXXXXXXXXX
ustar(k)=uk;
str=sprintf('#####  k=%d uk=%g Ncalls=%d',k, uk,Ncalls(k));
disp(str);
X0=step_loop(k,X0,uk);
end
%///////////////
disp(ustar);
t_vector=0:delt:horiz;
X00=[1. 150. 0. 10.];

u_vector=ustar; 
command_index=1;
ti=0;
tf=horiz;
options = odeset('RelTol',0.01,'MaxStep',1., 'NonNegative',[1,2,3,4]);
[T,Y] = ode23('EtanolProd',[ti tf],X00,options);

IF=length(T); %IF este indicile final

J=Y(IF,3)*Y(IF,4); % J=x3(tf)*x4(tf) 
str=sprintf('*******  Jmax=%8.1f',J);
 disp(str);
%State evolution over the control horizaon
%plot(T,Y(:,1),'k',T,Y(:,2),'g',T,Y(:,3),'b',T,Y(:,4),'r');
% axis([0.,54.,0.,250.])
save('WspEA_EP_loop');
%\\\\\\\\\\\\\\\\\\\\
